
Global square,computermove, sound1, sound2, sound3, sound4  
Global mx,my,column,row, oldcolumn, oldrow, score, gameover
Global loop, md, event, timer1 , t1 , t2
Global piece,m1 = 0
Dim brd(20,20)    ; Board Square colors
Dim brd2(20,20)   ; Board piece colors
Dim lb(20,20)     ; Logic Bomb
Dim sp(60)
Dim sp2(60)

Function Start()
 ; Start Program
End Function 
 
Setup1()

Graphics 1200,800,32,2

Setup2()

SetBuffer BackBuffer()
ClsColor 0,0,10
                                 

;@@@@@@@@@@@@@@@@@@@@@@@@@@@ start main loop @@@@@@@@@@@@@@@@@@@@@@@@@@
While loop=1
  Delay 2
  Cls
  WaitTimer(timer1)
  If gameover = 1 Then
     EndGame()
  Else 
     MouseLogic()
     PrintText()
     EventLogic()
     PlayerLogic1()
     PlayerLogic2()
     ComputerLogic()
     UpDateBoard()
     DrawBoard()
     Checkscore()
  End If 
  VWait 
  Flip

Wend 
 
 FreeImage square
 FreeTimer timer1
 For a = 1 To 10 
  FreeImage sp(a)
 Next
 FreeSound sound1
 FreeSound sound2
 FreeSound sound3
 FreeSound sound4

End  ; @@@@@@@@@ Program End @@@@@@@@

Function EndGame()
  Local value 
  Local a = 1
     PrintText()
     UpDateBoard()
     DrawBoard()

  Text 300,550," GAME OVER "
  VWait 
  Flip

  While a = 1
     Delay 90 
     value=GetKey()
     If value = 32 Then 
       loop=0 
       a = 0                ; break out of loop
     End If
  Wend 
End Function 

Function Checkscore()

Local a,b,c
 score = 0
 For b = 1 To 3  
   For a= 1 To 8 
     If brd2(a,b) = 1 Then score = score + 1
    Next
 Next
 If score = 12 Then gameover = 1

 For b = 6 To 8  
   For a= 1 To 8 
     If brd2(a,b) = 10 Then score = score - 1 : c = c + 1
    Next
 Next
 score = score * 10
  If c = 12 Then gameover = 1
End Function


Function Setup1()
 Local a,b,c
 loop=1
 SeedRnd MilliSecs() 
 event = 1
 sound1 = LoadSound ("snd\click.wav")
 sound2 = LoadSound ("snd\beep2.wav")
 sound3 = LoadSound ("snd\beep6.wav")
 sound4 = LoadSound ("snd\ding.wav")
 score = 0
 gameover = 0
 computermove = 0
 c=0
 For b = 1 To 8  ; make checkerboard
   For a= 1 To 8 
     ;brd (a,b)=Rand(1,10)
     c=c+1
     If c>2 Then c=1
      If c=1 Then
       brd (a,b)=8
       If b>5 Then brd2(a,b)=1
       If b<4 Then brd2(a,b)=10
      EndIf 
     If a=8 Then c=c+1
     If c>2 Then c=1
   Next
 Next 

 timer1 = CreateTimer(60)

End Function 

Function Setup2()
 ;$$$$$$$$$$$$$$$$$$$$  sprite section $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
Local a
For a = 1 To 10 
sp(a)=CreateImage(52,52)          ; create 10 empty sprite 
SetBuffer ImageBuffer(sp(a))       ; draw on sprite
;Color a,20,50
If a= 1 Then Color 255,0,0          ;red
If a= 2 Then Color 255,100,0        ;orange
If a= 3 Then Color 255,255,0        ;yellow
If a= 4 Then Color 50,255,50          ;green
If a= 5 Then Color 0,0,255          ;blue
If a= 6 Then Color 255,0,255        ;violet
If a= 7 Then Color 255,100,100      ;pink
If a= 8 Then Color 50,180,205       ; bluegreen 
If a= 9 Then Color 205,205,205      ;white
If a= 10 Then Color 1,1,1           ;black

Rect 0,0,52,52,1
Next

For a = 1 To 10 
sp2(a)=CreateImage(54,54)          ; create 10 empty sprite 
SetBuffer ImageBuffer(sp2(a))       ; draw on sprite
;Color a,20,50
If a= 1 Then Color 255,0,0          ;red
If a= 2 Then Color 255,100,0        ;orange
If a= 3 Then Color 255,255,0        ;yellow
If a= 4 Then Color 0,255,0          ;green
If a= 5 Then Color 0,0,255          ;blue
If a= 6 Then Color 255,0,255        ;violet
If a= 7 Then Color 255,100,100      ;pink
If a= 8 Then Color 0,255,255        ;bright bluegreen 
If a= 9 Then Color 255,255,255      ;white
If a= 10 Then Color 1,1,20        ;black

Oval 2,3,49,49,1
Next

 
square=CreateImage(54,54)          ; create empty sprite 
SetBuffer ImageBuffer(square)       ; draw on sprite
Color 0,20,50
Rect 0,0,54,52,1




End Function 


Function MouseLogic()

 Local rx,ry
  If MouseDown(1) And md=0   Then 
 md=1
 
EndIf

value=GetKey()
If value = 32 Then 
loop=0                 ; break out of loop
End If 
mx=MouseX()            ; get mouse position
my=MouseY()
rx=mx-190              ; get x position relative to board
If rx<1 Then rx=1
column=rx/54+1             ; get board column position

ry=my-30               ; get y position relative to board
If ry<1 Then ry=1
row=ry/54+1             ; get board row position
If column>8 Then column=8      ; make limits 
If row>8 Then row=8
If column<0 Then column=0 
If row<0 Then row=0
 
End Function 


Function PrintText()
   Color 255,255,255


Text 10,80,"Hit space bar to end "
Text 10,95,"program"

If event3<9 Then 
 Text 2,130," The object of this
 Text 2,145,"game is to move all
 Text 2,160,"your pieces to the top
 Text 2,175,"3 rows before the
 Text 2,190," computer does.

 Text 2,225,"The rules are like 
 Text 2,240,"Chinese checkers.
 Text 2,255,"You can jump pieces of 
 Text 2,270,"any color and move in
 Text 2,285,"any direction, but 
 Text 2,300,"there is no capturing
 Text 2,315,"of pieces.

 Text 2,500," http://rb23.yolasite.com "
EndIf 



Text 50,400,"x ="         ; print variable names
Text 50,415,"y ="
Text 50,430,"column ="
Text 50,445,"row ="
Text 50,460," move "
Text 50,475,"event="



Text 120,400, mx          ; print values
Text 120,415, my
Text 120,430, column
Text 120,445, row
Text 120,460, computermove
Text 120,475, event
Text 100,550,"SCORE = " : Text 160,550, score

 
End Function 


Function EventLogic()
  
            
    event=event+1
    If event = 9 event = 1
    If event = 19 event = 11
    If event = 29 event = 21
    If event = 39 event = 31
    If event = 49 event = 41
    If event = 59 event = 51
    If event = 69 event = 61
    If event = 79 event = 71

    If event > 99 Then event = 1            
 

End Function 

Function PlayerLogic1()
  If event = 8 And md=1 And MouseDown(1) = 0 Then
    
   piece = brd2(column,row) ; 1= player piece   10= computer piece
   If piece=1 Then 
    brd2(column,row)=0
    oldcolumn = column
    oldrow = row
    event = 10
    PlaySound sound1
   EndIf
 
   If piece <> 1 Then
     event = 1 ; abort move
     PlaySound sound4
   EndIf 
   md = 0
 EndIf

  
End Function 

Function CheckMove()
   Local move = 0 
   Local c1,c2,r1,r2
   Local cnt,ccnt,rcnt
   Local mv
   c1 = column
   c2 = oldcolumn
   r1 = row
   r2 = oldrow
   For rcnt = 1 To 8

       For ccnt = 1 To 8
          lb(ccnt,rcnt) = 0
          If ccnt = oldcolumn And rcnt = oldrow Then  lb(ccnt,rcnt) = 1

       Next

   Next
 For cnt = 1 To 10
   For rcnt = 1 To 8

       For ccnt = 1 To 8
          If ccnt < 7 And rcnt > 2 And lb(ccnt,rcnt) = 1 And brd2(ccnt+1,rcnt-1) > 0 And brd2(ccnt+2,rcnt-2) = 0 Then  lb(ccnt+2,rcnt-2) = 1
          If ccnt > 2 And rcnt > 2 And lb(ccnt,rcnt) = 1 And brd2(ccnt-1,rcnt-1) > 0 And brd2(ccnt-2,rcnt-2) = 0 Then  lb(ccnt-2,rcnt-2) = 1         
          If ccnt > 2 And rcnt < 7 And lb(ccnt,rcnt) = 1 And brd2(ccnt-1,rcnt+1) > 0 And brd2(ccnt-2,rcnt+2) = 0 Then  lb(ccnt-2,rcnt+2) = 1
          If ccnt < 7 And rcnt < 7 And lb(ccnt,rcnt) = 1 And brd2(ccnt+1,rcnt+1) > 0 And brd2(ccnt+2,rcnt+2) = 0 Then  lb(ccnt+2,rcnt+2) = 1 
       Next

   Next
 Next

 
   If c2 + 1 = c1 And r2 - 1 = r1 Then move = 1 : m1 = 1
   If c2 - 1 = c1 And r2 - 1 = r1 Then move = 1 : m1 = 2
   If c2 + 1 = c1 And r2 + 1 = r1 Then move = 1 : m1 = 3
   If c2 - 1 = c1 And r2 + 1 = r1 Then move = 1 : m1 = 4

   mv = lb(column,row)
   If move = 0 Then move = mv       


   Return move
End Function 

Function PlayerLogic2()
   Local move = 0
   If event = 18 And md = 1 And MouseDown(1) = 0 Then
     move = CheckMove()

     If brd2(column,row) = 0 And move = 1 Then 
       brd2(column,row)=piece
       event = 20 
       md = 0
       PlaySound sound2

   UpDateBoard()
   DrawBoard()

       VWait 
       Flip

     Else 
       brd2(oldcolumn,oldrow) = 1 ; abort move
       event = 1
       md = 0
     EndIf 
   EndIf
   
End Function

Function CheckMove2(c1,r1,c2,r2) ; column, row, oldcolumn, oldrow
   Local move = 0 
   
   Local cnt,ccnt,rcnt,dir
   Local mv, cnt3 = 0, c3 = 0, r3 = 0, cnt4 = 0
 
t1 = c1 : t2 =  r1

   For rcnt = 1 To 8

       For ccnt = 1 To 8
          lb(ccnt,rcnt) = 0
          If ccnt = c2 And rcnt = r2 Then  lb(ccnt,rcnt) = 1

       Next

   Next
 For cnt = 1 To 4
   For rcnt = 1 To 8

       For ccnt = 1 To 8
          If ccnt < 7 And rcnt > 2 And lb(ccnt,rcnt) = 1 And brd2(ccnt+1,rcnt-1) > 0 And brd2(ccnt+2,rcnt-2) = 0 Then  lb(ccnt+2,rcnt-2) = 1
          If ccnt > 2 And rcnt > 2 And lb(ccnt,rcnt) = 1 And brd2(ccnt-1,rcnt-1) > 0 And brd2(ccnt-2,rcnt-2) = 0 Then  lb(ccnt-2,rcnt-2) = 1         
          If ccnt > 2 And rcnt < 7 And lb(ccnt,rcnt) = 1 And brd2(ccnt-1,rcnt+1) > 0 And brd2(ccnt-2,rcnt+2) = 0 Then  lb(ccnt-2,rcnt+2) = 1
          If ccnt < 7 And rcnt < 7 And lb(ccnt,rcnt) = 1 And brd2(ccnt+1,rcnt+1) > 0 And brd2(ccnt+2,rcnt+2) = 0 Then  lb(ccnt+2,rcnt+2) = 1
          
       Next

   Next
 Next

   If brd2(c1,r1) = 0 Then 
     If c2 + 1 = c1 And r2 - 1 = r1 Then move = 1 
     If c2 - 1 = c1 And r2 - 1 = r1 Then move = 1 
     If c2 + 1 = c1 And r2 + 1 = r1 Then move = 2 
     If c2 - 1 = c1 And r2 + 1 = r1 Then move = 2 
   End If
   For rcnt = 6 To 8

       For ccnt = 1 To 8
          If brd2( ccnt,rcnt ) = 0 Then 
              c3 = ccnt : r3 = rcnt
          End If
       Next

   Next
 
     ; (c1,r1,c2,r2)  column, row, oldcolumn, oldrow
 
 
     If lb(c1,r1) = 1   Then move =  move + r1-r2
       If move > 0
 
           If r1 > r2 Then move = move + 2
           If c3 = 8 And r3 = 6 And c1 = 8 And c2 = 7 And r1 = 6 Then move = move + 1
           If c3 = 2 And r3 = 6 And c1 = 2 And c2 = 3 And r1 = 6 Then move = move + 1
           If c3 = 8 And r3 = 6 And r2 < 6 And c2 < 8 And c2 < c1 Then move = move + 2
           If c3 = 2 And r3 = 6 And r2 < 6 And c2 > 2 And c2 > c1 Then move = move + 2
           If c2 = 2 And r2 = 6 And r1 = 5 Then move = 0
           If c2 = 8 And r2 = 6 And r1 = 5 Then move = 0
           If c2 = 2 And r2 = 6 And r1 = 7 And computermove > 55 Then move = 0
           If c2 = 8 And r2 = 6 And r1 = 7 And computermove > 55 Then move = 0
           If c3 = 8 And r3 = 6 And r2 = 7 And c2 = 7 And c2 < c1 And computermove> 55 Then move = move + 2
           If c2 = 1 And r2 = 7 And r1 = 6 Then move = 0
           If c2 = 7 And r2 = 7 And r1 = 6 And c1 = 8 And computermove > 55 Then move = move + 2
           If  r1 = 5 And c1 = 1 And computermove > 55 Then move = 0


       End If 
 
   Return move
End Function 

Function ComputerLogic()
 Local cnt = 0
 Local cnt2=0,a=0,b=0,c=0
 Local rcnt,ccnt 
 Local c1,r1,c2,r2,c3,r3
 If event = 20  Then
  ;(c1,r1,c2,r2)  column, row, oldcolumn, oldrow

  cnt=0
  While cnt< 300         ; find random computer piece
     cnt2 = 0
     While cnt2< 300
       c2=Rand(1,8) 
       r2=Rand(1,8)
       c=brd2(c2,r2)
       If c= 10 Then cnt2=2000
       cnt2=cnt2+1

     Wend
    
   For rcnt = 1 To 8

       For ccnt = 1 To 8
          
            a = CheckMove2(ccnt,rcnt,c2,r2) ; Is this move legal?
            If a > b Then
               c1=ccnt
               r1 = rcnt
               c3 = c2
               r3 = r2
              ; brd2(c2,r2) = 0
              ; brd2(c1,r1) = 10
              b = a  
              computermove = computermove + 1
            End If 
       Next

   Next

    
   cnt=cnt+1
  Wend
  brd2(c3,r3) = 0
  brd2(c1,r1) = 10
  PlaySound sound3

  event = 1
EndIf 

End Function 


Function UpDateBoard()
 
 Local clr1,clr2,col,rw
 Color 0,200,50


 x=192                      ; x,y starting points
 y=31

 For rw = 1 To 8              ; Draw 64 squares or objects

         
      For col = 1 To 8
         
         
          DrawImage square,x,y        ; Draw the image (sprite)
        
          clr1 =  brd(col,rw)
          If clr1 > 0 Then
            DrawImage sp(clr1),x,y      ; clr1 = color of square
          End If 
          clr2 =  brd2(col,rw)
          If clr2 > 0 Then

            DrawImage sp2(clr2),x,y    ; draw piece  1 = red   10 = black
          End If 
 
          x=x+54              ; increase x row 48, each loop   
      Next 
   x=192                      ; x starting point
   y=y+54                     ; increase y row 48, each loop
 Next
End Function 

Function DrawBoard()
 Local x,y,x2,y2,cnt 
   Color 50,200,255                     ; blue green
 x=189                                ; start points
 y=29
 y2=31

 For cnt = 1 To 9
   Line x,y,622,y                     ; draw 11 horizontal lines
   Line x,y2,622,y2                   ; draw 11 horizontal lines
   y=y+54                             ; endpoint = 660 = 180+10*48
   y2=y2+54

 Next 

 Color 50,255,255
 x=189                                ; start points
 y=29
 x2=191

 For  cnt = 1 To 9
   Line x,y,x,462                     ; draw 11 vertical lines
   Line x2,y,x2,462                   ; draw 11 vertical lines
   x=x+54
   x2=x2+54                           ; endpoint = 529
                   
 Next 



End Function 